
<!DOCTYPE html>

<html>
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>LSTM_chemistry &#8212; Battery SOH 2022 documentation</title>
    
  <link href="../_static/css/theme.css" rel="stylesheet" />
  <link href="../_static/css/index.c5995385ac14fb8791e8eb36b4908be2.css" rel="stylesheet" />

    
  <link rel="stylesheet"
    href="../_static/vendor/fontawesome/5.13.0/css/all.min.css">
  <link rel="preload" as="font" type="font/woff2" crossorigin
    href="../_static/vendor/fontawesome/5.13.0/webfonts/fa-solid-900.woff2">
  <link rel="preload" as="font" type="font/woff2" crossorigin
    href="../_static/vendor/fontawesome/5.13.0/webfonts/fa-brands-400.woff2">

    
      

    
    <link rel="stylesheet" type="text/css" href="../_static/pygments.css" />
    <link rel="stylesheet" type="text/css" href="../_static/basic.css" />
    
  <link rel="preload" as="script" href="../_static/js/index.1c5a1a01449ed65a7b51.js">

    <script data-url_root="../" id="documentation_options" src="../_static/documentation_options.js"></script>
    <script src="../_static/jquery.js"></script>
    <script src="../_static/underscore.js"></script>
    <script src="../_static/doctools.js"></script>
    <script crossorigin="anonymous" integrity="sha256-Ae2Vz/4ePdIu6ZyI/5ZGsYnb+m0JlOmKPjt6XZ9JJkA=" src="https://cdnjs.cloudflare.com/ajax/libs/require.js/2.3.4/require.min.js"></script>
    <link rel="index" title="Index" href="../genindex.html" />
    <link rel="search" title="Search" href="../search.html" />
    <meta name="viewport" content="width=device-width, initial-scale=1" />
    <meta name="docsearch:language" content="en" />
    
  </head>
  <body data-spy="scroll" data-target="#bd-toc-nav" data-offset="80">
    
    <div class="container-fluid" id="banner"></div>

    
    <nav class="navbar navbar-light navbar-expand-lg bg-light fixed-top bd-navbar" id="navbar-main"><div class="container-xl">

  <div id="navbar-start">
    
    

<a class="navbar-brand" href="../index.html">
  <img src="../_static/logo.png" class="logo" alt="logo">
</a>


    
  </div>

  <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbar-collapsible" aria-controls="navbar-collapsible" aria-expanded="false" aria-label="Toggle navigation">
    <span class="navbar-toggler-icon"></span>
  </button>

  
  <div id="navbar-collapsible" class="col-lg-9 collapse navbar-collapse">
    <div id="navbar-center" class="mr-auto">
      
      <div class="navbar-center-item">
        <ul id="navbar-main-elements" class="navbar-nav">
    <li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="../sphinx/Colabs.html">
  Google Colabs
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="../sphinx/main.html">
  Useful dictionaries
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="../sphinx/Battery%20Classes.html">
  Battery Classes
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="../sphinx/Cleaning.html">
  Treatment functions
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="../sphinx/Models.html">
  Models
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="../sphinx/Training.html">
  Training and Simulation
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="../sphinx/Report.html">
  Report related
 </a>
</li>

    
</ul>
      </div>
      
    </div>

    <div id="navbar-end">
      
      <div class="navbar-end-item">
        <ul id="navbar-icon-links" class="navbar-nav" aria-label="Icon Links">
      </ul>
      </div>
      
    </div>
  </div>
</div>
    </nav>
    

    <div class="container-xl">
      <div class="row">
          
            
            <!-- Only show if we have sidebars configured, else just a small margin  -->
            <div class="col-12 col-md-3 bd-sidebar"><form class="bd-search d-flex align-items-center" action="../search.html" method="get">
  <i class="icon fas fa-search"></i>
  <input type="search" class="form-control" name="q" id="search-input" placeholder="Search the docs ..." aria-label="Search the docs ..." autocomplete="off" >
</form><nav class="bd-links" id="bd-docs-nav" aria-label="Main navigation">
  <div class="bd-toc-item active">
    
  </div>
</nav>
            </div>
            
          

          
          <div class="d-none d-xl-block col-xl-2 bd-toc">
            
          </div>
          

          
          
            
          
          <main class="col-12 col-md-9 col-xl-7 py-md-5 pl-md-5 pr-md-4 bd-content" role="main">
              
              <div>
                
  <h1>Source code for LSTM_chemistry</h1><div class="highlight"><pre>
<span></span><span class="kn">from</span> <span class="nn">Cleaning</span> <span class="kn">import</span> <span class="o">*</span>
<span class="kn">from</span> <span class="nn">Training</span> <span class="kn">import</span> <span class="o">*</span>
<span class="kn">from</span> <span class="nn">torch.utils.data</span> <span class="kn">import</span> <span class="n">Dataset</span><span class="p">,</span> <span class="n">DataLoader</span>
<span class="kn">import</span> <span class="nn">torch.nn.functional</span> <span class="k">as</span> <span class="nn">F</span>
<span class="kn">import</span> <span class="nn">torch.nn</span> <span class="k">as</span> <span class="nn">nn</span>
<span class="kn">import</span> <span class="nn">re</span>
<span class="kn">from</span> <span class="nn">LSTM_Base</span> <span class="kn">import</span> <span class="n">LSTM_Base</span><span class="p">,</span> <span class="n">Dataset_Base</span>

<div class="viewcode-block" id="LSTM_v1"><a class="viewcode-back" href="../sphinx/LSTMchem.html#LSTM_chemistry.LSTM_v1">[docs]</a><span class="k">class</span> <span class="nc">LSTM_v1</span><span class="p">(</span><span class="n">LSTM_Base</span><span class="p">):</span>
    <span class="sd">&quot;&quot;&quot;LSTM type neural net for Battery SOH estimation.</span>

<span class="sd">    This model acts just like :class:`LSTM.LSTM_v1`, but also takes the</span>
<span class="sd">    dataset&#39;s chemistry as an input in the regression layer (much like</span>
<span class="sd">    :class:`LSTM.LSTM_v4` takes the ambient temperature as input).</span>

<span class="sd">    A Li-ion dataset will have an input of 0, whilst a Na-ion dataset will have</span>
<span class="sd">    and input of 1.</span>

<span class="sd">    For more information about the model&#39;s architecture, check the documentation</span>
<span class="sd">    for :class:`LSTM.LSTM_v1`.</span>

<span class="sd">    Parameters</span>
<span class="sd">    ----------</span>
<span class="sd">    delta : int</span>
<span class="sd">        The size of the sliding window used to generate the x_i&#39;s.</span>
<span class="sd">    hidden_dim : int</span>
<span class="sd">        Hidden dimension of the LSTM (also its main output dimension).</span>
<span class="sd">    pooling_layer : {&#39;last&#39;, &#39;mean&#39;, &#39;bi_mean&quot;}</span>
<span class="sd">        Decides the type of pooling layer:</span>
<span class="sd">        - &#39;last&#39; (only take the last result),</span>
<span class="sd">        - &#39;mean&#39; (take the mean of the results) and</span>
<span class="sd">        - &#39;bi_mean&#39; (take the mean of the product).</span>
<span class="sd">    drop_out : float</span>
<span class="sd">        The probability of the dropout layer that comes right after the LSTM.</span>
<span class="sd">        Must be a number between 0 and 1.</span>
<span class="sd">    norm : tuple(Tensor, Tensor, Tensor, Tensor, string), optional</span>
<span class="sd">        A tuple containing all of the information necessary for normalization.</span>

<span class="sd">        This isn&#39;t a necessary parameter and is not used in the model in any</span>
<span class="sd">        way. It&#39;s just useful for documentation purposes and for normalizing</span>
<span class="sd">        test and validation sets.</span>

<span class="sd">    version : int, default = 1</span>
<span class="sd">        The model version to be used.</span>

<span class="sd">        * ``version`` = 1 corresponds to the model created by the article cited.</span>
<span class="sd">        * ``version`` = 2 corresponds to the same model, but adapted to also</span>
<span class="sd">          take the charge cycle&#39;s temperature data.</span>
<span class="sd">        * ``version`` = 3 is similar to version 1, but takes the ambient</span>
<span class="sd">          temperature as an extra inputs.</span>

<span class="sd">    lin_layers : int, default = 1</span>
<span class="sd">        The number of linear regression layers. As of now, cannot be greater</span>
<span class="sd">        than two.</span>
<span class="sd">    lin_dropout : float, optional</span>
<span class="sd">        The value for the dropout layer that comes after the first linear layer</span>
<span class="sd">        in the regression step. Will only be added if ``lin_layers`` &gt; 1.</span>

<span class="sd">    Raises</span>
<span class="sd">    ------</span>
<span class="sd">    AssertionError</span>
<span class="sd">        If the version in different than 1, 2 or 3.</span>
<span class="sd">        If an unsupported pooling_layer is informed.</span>

<span class="sd">    Examples</span>
<span class="sd">    --------</span>
<span class="sd">    &gt;&gt;&gt; from torch.utils.data import Dataset</span>
<span class="sd">    &gt;&gt;&gt; from LSTM import *</span>
<span class="sd">    &gt;&gt;&gt; delta = 10</span>
<span class="sd">    &gt;&gt;&gt; hidden_dim = 20</span>
<span class="sd">    &gt;&gt;&gt; version = 2</span>
<span class="sd">    &gt;&gt;&gt; model = LSTM_v1(delta, hidden_dim, pooling_layer=&#39;last&#39;, version=version)</span>
<span class="sd">    &gt;&gt;&gt; with open(&#39;B0005.txt&#39;, &#39;rb&#39;) as f:</span>
<span class="sd">    ...     Battery = pickle.load(f)</span>
<span class="sd">    ...</span>
<span class="sd">    &gt;&gt;&gt; train_dataset = Torch_Dataset_LSTM([Battery], delta, version, fixed_len=150)</span>
<span class="sd">    &gt;&gt;&gt; estimated_capacity = model(train_dataset.inputs[0])</span>
<span class="sd">    &gt;&gt;&gt; loss_function = th.nn.MSELoss()</span>
<span class="sd">    &gt;&gt;&gt; loss = loss_function(estimated_capacity, train_dataset.output[0])</span>
<span class="sd">    2.2862</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="k">def</span> <span class="fm">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">delta</span><span class="p">,</span> <span class="n">hidden_dim</span><span class="p">,</span> <span class="n">pooling_layer</span><span class="o">=</span><span class="s1">&#39;bi_mean&#39;</span><span class="p">,</span> <span class="n">drop_out</span><span class="o">=</span><span class="mi">0</span><span class="p">,</span>
                 <span class="n">norm</span><span class="o">=</span><span class="kc">None</span><span class="p">,</span> <span class="n">version</span><span class="o">=</span><span class="mi">1</span><span class="p">,</span> <span class="n">lin_layers</span><span class="o">=</span><span class="mi">1</span><span class="p">,</span> <span class="n">lin_dropout</span><span class="o">=</span><span class="mi">0</span><span class="p">):</span>

        <span class="nb">super</span><span class="p">()</span><span class="o">.</span><span class="fm">__init__</span><span class="p">()</span>

        <span class="k">assert</span> <span class="n">version</span> <span class="ow">in</span> <span class="p">[</span><span class="mi">1</span><span class="p">,</span> <span class="mi">2</span><span class="p">,</span> <span class="mi">3</span><span class="p">],</span> \
            <span class="s2">&quot;Unsupported version. For versions 4 and 5, call LSTM_v4 instead.&quot;</span>

        <span class="c1"># Model information:</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">version</span> <span class="o">=</span> <span class="n">version</span>                      <span class="c1"># The kind of model</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">variant</span> <span class="o">=</span> <span class="s1">&#39;chemistry&#39;</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">pooling_layer</span> <span class="o">=</span> <span class="n">pooling_layer</span>          <span class="c1"># The type of pooling layer</span>
        <span class="c1"># Normalization information:</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">norm</span> <span class="o">=</span> <span class="n">norm</span>                            <span class="c1"># The normalization used</span>

        <span class="c1"># Important dimensions</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">delta</span> <span class="o">=</span> <span class="n">delta</span>                          <span class="c1"># The sliding window size</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">hidden_dim</span> <span class="o">=</span> <span class="n">hidden_dim</span>                <span class="c1"># Hidden dimension (LSTM)</span>

        <span class="c1"># Input Dimension (number of input variables)</span>
        <span class="k">if</span> <span class="n">version</span> <span class="o">==</span> <span class="mi">1</span><span class="p">:</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">inputs_dim</span> <span class="o">=</span> <span class="mi">2</span> <span class="o">*</span> <span class="n">delta</span>             <span class="c1"># (I, V) * delta</span>
        <span class="k">elif</span> <span class="n">version</span> <span class="o">==</span> <span class="mi">2</span><span class="p">:</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">inputs_dim</span> <span class="o">=</span> <span class="mi">3</span> <span class="o">*</span> <span class="n">delta</span>             <span class="c1"># (I, V, T) * delta</span>
        <span class="k">elif</span> <span class="n">version</span> <span class="o">==</span> <span class="mi">3</span><span class="p">:</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">inputs_dim</span> <span class="o">=</span> <span class="mi">2</span> <span class="o">*</span> <span class="n">delta</span> <span class="o">+</span> <span class="mi">1</span>         <span class="c1"># (I, V) * delta + T_amb</span>

        <span class="bp">self</span><span class="o">.</span><span class="n">output_dim</span> <span class="o">=</span> <span class="mi">1</span>

        <span class="bp">self</span><span class="o">.</span><span class="n">dropout_value</span> <span class="o">=</span> <span class="n">drop_out</span>

        <span class="k">assert</span> <span class="p">(</span><span class="n">pooling_layer</span> <span class="o">==</span> <span class="s1">&#39;last&#39;</span><span class="p">)</span> <span class="ow">or</span> <span class="p">(</span><span class="n">pooling_layer</span> <span class="o">==</span> <span class="s1">&#39;mean&#39;</span><span class="p">)</span> <span class="ow">or</span>\
               <span class="p">(</span><span class="n">pooling_layer</span> <span class="o">==</span> <span class="s1">&#39;bi_mean&#39;</span><span class="p">),</span> <span class="s2">&quot;pooling_layer&quot;</span>\
               <span class="s2">&quot; either &#39;last&#39;, &#39;mean&#39; or &#39;bi_mean&quot;</span>

        <span class="c1"># If the pooling layer requires the LSTM to be of bidirectional type</span>
        <span class="k">if</span> <span class="n">pooling_layer</span> <span class="o">==</span> <span class="s1">&#39;bi_mean&#39;</span><span class="p">:</span>
            <span class="n">bi_bool</span> <span class="o">=</span> <span class="kc">True</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="n">bi_bool</span> <span class="o">=</span> <span class="kc">False</span>

        <span class="c1"># Definition of the LSTM itself</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">lstm</span> <span class="o">=</span> <span class="n">nn</span><span class="o">.</span><span class="n">LSTM</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">inputs_dim</span><span class="p">,</span> <span class="n">hidden_dim</span><span class="p">,</span> <span class="n">batch_first</span><span class="o">=</span><span class="kc">True</span><span class="p">,</span>
                            <span class="n">bidirectional</span><span class="o">=</span><span class="n">bi_bool</span><span class="p">)</span>

        <span class="c1"># The linear layer that maps from hidden state space to tag space</span>
        <span class="k">if</span> <span class="n">lin_layers</span> <span class="o">==</span> <span class="mi">1</span><span class="p">:</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">lin1</span> <span class="o">=</span> <span class="n">nn</span><span class="o">.</span><span class="n">Linear</span><span class="p">(</span><span class="n">hidden_dim</span><span class="o">+</span><span class="mi">1</span><span class="p">,</span> <span class="bp">self</span><span class="o">.</span><span class="n">output_dim</span><span class="p">)</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">nb_layers</span> <span class="o">=</span> <span class="mi">1</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">nb_layers</span> <span class="o">=</span> <span class="mi">2</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">lin0</span> <span class="o">=</span> <span class="n">nn</span><span class="o">.</span><span class="n">Linear</span><span class="p">(</span><span class="n">hidden_dim</span><span class="o">+</span><span class="mi">1</span><span class="p">,</span> <span class="n">hidden_dim</span><span class="o">//</span><span class="mi">2</span><span class="p">)</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">actf</span> <span class="o">=</span> <span class="n">nn</span><span class="o">.</span><span class="n">LeakyReLU</span><span class="p">()</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">lin2</span> <span class="o">=</span> <span class="n">nn</span><span class="o">.</span><span class="n">Linear</span><span class="p">(</span><span class="n">hidden_dim</span><span class="o">//</span><span class="mi">2</span><span class="p">,</span> <span class="bp">self</span><span class="o">.</span><span class="n">output_dim</span><span class="p">)</span>
            <span class="c1"># self.lin3 = nn.Linear(hidden_dim//4, self.output_dim)</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">lin_dropout_fn</span> <span class="o">=</span> <span class="n">nn</span><span class="o">.</span><span class="n">Dropout</span><span class="p">(</span><span class="n">lin_dropout</span><span class="p">)</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">lin1</span> <span class="o">=</span> <span class="n">nn</span><span class="o">.</span><span class="n">Sequential</span><span class="p">(</span>
                <span class="bp">self</span><span class="o">.</span><span class="n">lin0</span><span class="p">,</span>
                <span class="bp">self</span><span class="o">.</span><span class="n">actf</span><span class="p">,</span>
                <span class="bp">self</span><span class="o">.</span><span class="n">lin_dropout_fn</span><span class="p">,</span>
                <span class="bp">self</span><span class="o">.</span><span class="n">lin2</span><span class="p">,</span>
            <span class="p">)</span>

<div class="viewcode-block" id="LSTM_v1.forward"><a class="viewcode-back" href="../sphinx/LSTMchem.html#LSTM_chemistry.LSTM_v1.forward">[docs]</a>    <span class="k">def</span> <span class="nf">forward</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">inputs</span><span class="p">):</span>

        <span class="c1"># Input dimensions: [Batch size, Number of Xis (sequence length), 2*Delta]</span>
        <span class="k">if</span> <span class="nb">len</span><span class="p">(</span><span class="n">inputs</span><span class="o">.</span><span class="n">shape</span><span class="p">)</span> <span class="o">&lt;</span> <span class="mi">3</span><span class="p">:</span>   <span class="c1"># When Batch size equals 1, the first dimension is ignored,</span>
                                    <span class="c1"># but it&#39;s necesssary for the LSTM. So we have to reshape the inputs.</span>
            <span class="n">inputs</span> <span class="o">=</span> <span class="n">inputs</span><span class="o">.</span><span class="n">view</span><span class="p">(</span><span class="mi">1</span><span class="p">,</span> <span class="n">inputs</span><span class="o">.</span><span class="n">shape</span><span class="p">[</span><span class="mi">0</span><span class="p">],</span> <span class="n">inputs</span><span class="o">.</span><span class="n">shape</span><span class="p">[</span><span class="mi">1</span><span class="p">])</span>

        <span class="n">tech</span> <span class="o">=</span> <span class="n">inputs</span><span class="p">[:,</span> <span class="mi">0</span><span class="p">,</span> <span class="o">-</span><span class="mi">1</span><span class="p">]</span>  <span class="c1"># It doesn&#39;t change throughout the cycle</span>
        <span class="n">lstm_inputs</span> <span class="o">=</span> <span class="n">inputs</span><span class="p">[:,</span> <span class="p">:,</span> <span class="p">:</span><span class="o">-</span><span class="mi">1</span><span class="p">]</span>

        <span class="n">lstm_out</span><span class="p">,</span> <span class="n">_</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">lstm</span><span class="p">(</span><span class="n">lstm_inputs</span><span class="p">)</span>     <span class="c1"># LSTM output</span>
        <span class="n">shp_out</span> <span class="o">=</span> <span class="n">lstm_out</span><span class="o">.</span><span class="n">shape</span>            <span class="c1"># Its shape ([Batch size, Number of Xis (sequence length), self.hidden_dim])</span>
        <span class="n">lstm_out</span> <span class="o">=</span> <span class="n">F</span><span class="o">.</span><span class="n">dropout</span><span class="p">(</span><span class="n">lstm_out</span><span class="p">,</span> <span class="bp">self</span><span class="o">.</span><span class="n">dropout_value</span><span class="p">)</span>      <span class="c1"># dropout layer</span>

        <span class="c1"># Pooling layer, according to the type chosen:</span>
        <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">pooling_layer</span> <span class="o">==</span> <span class="s1">&#39;last&#39;</span><span class="p">:</span>
            <span class="n">pool_out</span> <span class="o">=</span> <span class="n">lstm_out</span><span class="p">[:,</span> <span class="o">-</span><span class="mi">1</span><span class="p">,</span> <span class="p">:]</span><span class="o">.</span><span class="n">view</span><span class="p">(</span><span class="n">shp_out</span><span class="p">[</span><span class="mi">0</span><span class="p">],</span> <span class="bp">self</span><span class="o">.</span><span class="n">hidden_dim</span><span class="p">)</span>         <span class="c1"># Only the last result</span>
        <span class="k">elif</span> <span class="bp">self</span><span class="o">.</span><span class="n">pooling_layer</span> <span class="o">==</span> <span class="s1">&#39;mean&#39;</span><span class="p">:</span>
            <span class="n">pool_out</span> <span class="o">=</span> <span class="n">th</span><span class="o">.</span><span class="n">mean</span><span class="p">(</span><span class="n">lstm_out</span><span class="p">,</span> <span class="n">dim</span><span class="o">=</span><span class="mi">1</span><span class="p">)</span><span class="o">.</span><span class="n">view</span><span class="p">(</span><span class="n">shp_out</span><span class="p">[</span><span class="mi">0</span><span class="p">],</span> <span class="bp">self</span><span class="o">.</span><span class="n">hidden_dim</span><span class="p">)</span>   <span class="c1"># Mean of the results</span>
        <span class="k">elif</span> <span class="bp">self</span><span class="o">.</span><span class="n">pooling_layer</span> <span class="o">==</span> <span class="s1">&#39;bi_mean&#39;</span><span class="p">:</span>
            <span class="n">pool_out</span> <span class="o">=</span> <span class="n">th</span><span class="o">.</span><span class="n">mean</span><span class="p">(</span><span class="n">lstm_out</span><span class="p">[:,</span> <span class="p">:,</span> <span class="p">:</span><span class="bp">self</span><span class="o">.</span><span class="n">hidden_dim</span><span class="p">]</span><span class="o">*</span>                    <span class="c1"># Mean of the multiplication</span>
                               <span class="n">lstm_out</span><span class="p">[:,</span> <span class="p">:,</span> <span class="bp">self</span><span class="o">.</span><span class="n">hidden_dim</span><span class="p">:],</span> <span class="n">dim</span><span class="o">=</span><span class="mi">1</span><span class="p">)</span><span class="o">.</span><span class="n">view</span><span class="p">(</span><span class="n">shp_out</span><span class="p">[</span><span class="mi">0</span><span class="p">],</span> <span class="bp">self</span><span class="o">.</span><span class="n">hidden_dim</span><span class="p">)</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="k">raise</span> <span class="ne">NameError</span><span class="p">(</span><span class="s2">&quot;Unknown pooling layer type: &quot;</span><span class="o">+</span><span class="bp">self</span><span class="o">.</span><span class="n">pooling_layer</span><span class="p">)</span>

        <span class="c1"># Linear layer</span>
        <span class="n">output</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">lin1</span><span class="p">(</span><span class="n">th</span><span class="o">.</span><span class="n">cat</span><span class="p">([</span><span class="n">pool_out</span><span class="p">,</span>
                                   <span class="n">tech</span><span class="o">.</span><span class="n">view</span><span class="p">(</span><span class="n">shp_out</span><span class="p">[</span><span class="mi">0</span><span class="p">],</span> <span class="mi">1</span><span class="p">)],</span> <span class="n">dim</span><span class="o">=</span><span class="mi">1</span><span class="p">))</span>

        <span class="k">return</span> <span class="n">output</span></div></div>

<div class="viewcode-block" id="LSTM_v4"><a class="viewcode-back" href="../sphinx/LSTMchem.html#LSTM_chemistry.LSTM_v4">[docs]</a><span class="k">class</span> <span class="nc">LSTM_v4</span><span class="p">(</span><span class="n">LSTM_Base</span><span class="p">):</span>
    <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">        LSTM type neural net for Battery SOH estimation.</span>

<span class="sd">    This model acts just like :class:`LSTM.LSTM_v4`, but also takes the</span>
<span class="sd">    dataset&#39;s chemistry as an input in the regression layer.</span>

<span class="sd">    A Li-ion dataset will have an input of 0, whilst a Na-ion dataset will have</span>
<span class="sd">    and input of 1.</span>

<span class="sd">    For more information about the model&#39;s architecture, check the documentation</span>
<span class="sd">    for :class:`LSTM.LSTM_v4`.</span>

<span class="sd">    Parameters</span>
<span class="sd">    ----------</span>
<span class="sd">    delta : int</span>
<span class="sd">        The size of the sliding window used to generate the x_i&#39;s.</span>
<span class="sd">    hidden_dim : int</span>
<span class="sd">        Hidden dimension of the LSTM (also its main output dimension).</span>
<span class="sd">    pooling_layer : {&#39;last&#39;, &#39;mean&#39;, &#39;bi_mean&quot;}</span>
<span class="sd">        Decides the type of pooling layer:</span>
<span class="sd">        - &#39;last&#39; (only take the last result),</span>
<span class="sd">        - &#39;mean&#39; (take the mean of the results) and</span>
<span class="sd">        - &#39;bi_mean&#39; (take the mean of the product).</span>
<span class="sd">    drop_out : float</span>
<span class="sd">        The probability of the dropout layer that comes right after the LSTM.</span>
<span class="sd">        Must be a number between 0 and 1.</span>
<span class="sd">    norm : tuple(Tensor, Tensor, Tensor, Tensor, string), optional</span>
<span class="sd">        A tuple containing all of the information necessary for normalization.</span>

<span class="sd">        This isn&#39;t a necessary parameter and is not used in the model in any</span>
<span class="sd">        way. It&#39;s just useful for documentation purposes and for normalizing</span>
<span class="sd">        test and validation sets.</span>
<span class="sd">    version : int, default = 4</span>
<span class="sd">        This is a new version being tested It will take the ambient temperature</span>
<span class="sd">        as an input directly into the linear layers.</span>
<span class="sd">        ``version`` = 4 corresponds to ``LSTM_v1``s version 1, and</span>
<span class="sd">        ``version`` = 5 corresponds to ``LSTM_v1``s version 2.</span>
<span class="sd">    lin_layers : int, default = 1</span>
<span class="sd">        The number of linear regression layers. As of now, cannot be greater</span>
<span class="sd">        than two.</span>
<span class="sd">    lin_dropout : float, optional</span>
<span class="sd">        The value for the dropout layer that comes after the first linear layer</span>
<span class="sd">        in the regression step. Will only be added if ``lin_layers &gt; 1``.</span>

<span class="sd">    Raises</span>
<span class="sd">    ------</span>
<span class="sd">    AssertionError</span>
<span class="sd">        If the version in different than 4 or 5.</span>
<span class="sd">        If an unsupported pooling_layer is informed.</span>

<span class="sd">    Examples</span>
<span class="sd">    --------</span>
<span class="sd">    &gt;&gt;&gt; from torch.utils.data import Dataset</span>
<span class="sd">    &gt;&gt;&gt; from LSTM import *</span>
<span class="sd">    &gt;&gt;&gt; delta = 10</span>
<span class="sd">    &gt;&gt;&gt; hidden_dim = 20</span>
<span class="sd">    &gt;&gt;&gt; version = 4</span>
<span class="sd">    &gt;&gt;&gt; model = LSTM_v4(delta, hidden_dim, pooling_layer=&#39;last&#39;, version=version)</span>
<span class="sd">    &gt;&gt;&gt; with open(&#39;B0005.txt&#39;, &#39;rb&#39;) as f:</span>
<span class="sd">    ...     Battery = pickle.load(f)</span>
<span class="sd">    ...</span>
<span class="sd">    &gt;&gt;&gt; train_dataset = Torch_Dataset_LSTM([Battery], delta, version, fixed_len=150)</span>
<span class="sd">    &gt;&gt;&gt; estimated_capacity = model(train_dataset.inputs[0])</span>
<span class="sd">    &gt;&gt;&gt; loss_function = th.nn.MSELoss()</span>
<span class="sd">    &gt;&gt;&gt; loss = loss_function(estimated_capacity, train_dataset.output[0])</span>
<span class="sd">    2.2862</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="k">def</span> <span class="fm">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">delta</span><span class="p">,</span> <span class="n">hidden_dim</span><span class="p">,</span> <span class="n">pooling_layer</span><span class="o">=</span><span class="s1">&#39;bi_mean&#39;</span><span class="p">,</span> <span class="n">drop_out</span><span class="o">=</span><span class="mi">0</span><span class="p">,</span>
                 <span class="n">norm</span><span class="o">=</span><span class="kc">None</span><span class="p">,</span> <span class="n">version</span><span class="o">=</span><span class="mi">4</span><span class="p">,</span> <span class="n">lin_layers</span><span class="o">=</span><span class="mi">1</span><span class="p">,</span> <span class="n">lin_dropout</span><span class="o">=</span><span class="mi">0</span><span class="p">):</span>

        <span class="nb">super</span><span class="p">()</span><span class="o">.</span><span class="fm">__init__</span><span class="p">()</span>

        <span class="k">assert</span> <span class="n">version</span> <span class="ow">in</span> <span class="p">[</span><span class="mi">4</span><span class="p">,</span> <span class="mi">5</span><span class="p">],</span> <span class="s2">&quot;This version is not supported. For versions 1 to 3, call LSTM_v1 instead.&quot;</span>

        <span class="c1"># Model information:</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">version</span> <span class="o">=</span> <span class="n">version</span>                      <span class="c1"># The kind of model</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">variant</span> <span class="o">=</span> <span class="s1">&#39;chemistry&#39;</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">pooling_layer</span> <span class="o">=</span> <span class="n">pooling_layer</span>          <span class="c1"># The type of pooling layer</span>
        <span class="c1"># Normalization information:</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">norm</span> <span class="o">=</span> <span class="n">norm</span>                            <span class="c1"># The normalization used</span>

        <span class="c1"># Important dimensions</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">delta</span> <span class="o">=</span> <span class="n">delta</span>                          <span class="c1"># The sliding window size</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">hidden_dim</span> <span class="o">=</span> <span class="n">hidden_dim</span>                <span class="c1"># Hidden dimension (LSTM)</span>

        <span class="c1"># Input Dimension (number of input variables)</span>
        <span class="k">if</span> <span class="n">version</span> <span class="o">==</span> <span class="mi">4</span><span class="p">:</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">inputs_dim</span> <span class="o">=</span> <span class="mi">2</span> <span class="o">*</span> <span class="n">delta</span>         <span class="c1"># (I, V) * delta + T_amb</span>
        <span class="k">if</span> <span class="n">version</span> <span class="o">==</span> <span class="mi">5</span><span class="p">:</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">inputs_dim</span> <span class="o">=</span> <span class="mi">3</span> <span class="o">*</span> <span class="n">delta</span>         <span class="c1"># (I, V) * delta + T_amb</span>

        <span class="bp">self</span><span class="o">.</span><span class="n">output_dim</span> <span class="o">=</span> <span class="mi">1</span>

        <span class="bp">self</span><span class="o">.</span><span class="n">dropout_value</span> <span class="o">=</span> <span class="n">drop_out</span>

        <span class="k">assert</span> <span class="p">(</span><span class="n">pooling_layer</span> <span class="o">==</span> <span class="s1">&#39;last&#39;</span><span class="p">)</span> <span class="ow">or</span> <span class="p">(</span><span class="n">pooling_layer</span> <span class="o">==</span> <span class="s1">&#39;mean&#39;</span><span class="p">)</span> <span class="ow">or</span>\
               <span class="p">(</span><span class="n">pooling_layer</span> <span class="o">==</span> <span class="s1">&#39;bi_mean&#39;</span><span class="p">),</span> <span class="s2">&quot;pooling_layer either &#39;last&#39;, &quot;</span> \
                                             <span class="s2">&quot;&#39;mean&#39; or &#39;bi_mean&quot;</span>

        <span class="c1"># If the pooling layer requires the LSTM to be of bidirectional type</span>
        <span class="k">if</span> <span class="n">pooling_layer</span> <span class="o">==</span> <span class="s1">&#39;bi_mean&#39;</span><span class="p">:</span>
            <span class="n">bi_bool</span> <span class="o">=</span> <span class="kc">True</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="n">bi_bool</span> <span class="o">=</span> <span class="kc">False</span>

        <span class="c1"># Definition of the LSTM itself</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">lstm</span> <span class="o">=</span> <span class="n">nn</span><span class="o">.</span><span class="n">LSTM</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">inputs_dim</span><span class="p">,</span> <span class="n">hidden_dim</span><span class="p">,</span> <span class="n">batch_first</span><span class="o">=</span><span class="kc">True</span><span class="p">,</span>
                            <span class="n">bidirectional</span><span class="o">=</span><span class="n">bi_bool</span><span class="p">)</span>

        <span class="c1"># The linear layer that maps from hidden state space to tag space</span>
        <span class="k">if</span> <span class="n">lin_layers</span> <span class="o">==</span> <span class="mi">1</span><span class="p">:</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">lin1</span> <span class="o">=</span> <span class="n">nn</span><span class="o">.</span><span class="n">Linear</span><span class="p">(</span><span class="n">hidden_dim</span><span class="o">+</span><span class="mi">2</span><span class="p">,</span> <span class="bp">self</span><span class="o">.</span><span class="n">output_dim</span><span class="p">)</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">nb_layers</span> <span class="o">=</span> <span class="mi">1</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">nb_layers</span> <span class="o">=</span> <span class="mi">2</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">lin0</span> <span class="o">=</span> <span class="n">nn</span><span class="o">.</span><span class="n">Linear</span><span class="p">(</span><span class="n">hidden_dim</span><span class="o">+</span><span class="mi">2</span><span class="p">,</span> <span class="n">hidden_dim</span> <span class="o">//</span> <span class="mi">2</span><span class="p">)</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">actf</span> <span class="o">=</span> <span class="n">nn</span><span class="o">.</span><span class="n">LeakyReLU</span><span class="p">()</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">lin2</span> <span class="o">=</span> <span class="n">nn</span><span class="o">.</span><span class="n">Linear</span><span class="p">(</span><span class="n">hidden_dim</span> <span class="o">//</span> <span class="mi">2</span><span class="p">,</span> <span class="bp">self</span><span class="o">.</span><span class="n">output_dim</span><span class="p">)</span>
            <span class="c1"># self.lin3 = nn.Linear(hidden_dim//4, self.output_dim)</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">lin_dropout_fn</span> <span class="o">=</span> <span class="n">nn</span><span class="o">.</span><span class="n">Dropout</span><span class="p">(</span><span class="n">lin_dropout</span><span class="p">)</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">lin1</span> <span class="o">=</span> <span class="n">nn</span><span class="o">.</span><span class="n">Sequential</span><span class="p">(</span>
                <span class="bp">self</span><span class="o">.</span><span class="n">lin0</span><span class="p">,</span>
                <span class="bp">self</span><span class="o">.</span><span class="n">actf</span><span class="p">,</span>
                <span class="bp">self</span><span class="o">.</span><span class="n">lin_dropout_fn</span><span class="p">,</span>
                <span class="bp">self</span><span class="o">.</span><span class="n">lin2</span><span class="p">,</span>
            <span class="p">)</span>

<div class="viewcode-block" id="LSTM_v4.forward"><a class="viewcode-back" href="../sphinx/LSTMchem.html#LSTM_chemistry.LSTM_v4.forward">[docs]</a>    <span class="k">def</span> <span class="nf">forward</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">inputs</span><span class="p">):</span>

        <span class="c1"># Input dimensions: [Batch size,Number of Xis (sequence length),2*Delta]</span>
        <span class="k">if</span> <span class="nb">len</span><span class="p">(</span><span class="n">inputs</span><span class="o">.</span><span class="n">shape</span><span class="p">)</span> <span class="o">&lt;</span> <span class="mi">3</span><span class="p">:</span>
            <span class="c1"># When Batch size equals 1, the first dimension is ignored,</span>
            <span class="c1"># but it&#39;s necesssary for the LSTM. So we have to reshape the inputs.</span>
            <span class="n">inputs</span> <span class="o">=</span> <span class="n">inputs</span><span class="o">.</span><span class="n">view</span><span class="p">(</span><span class="mi">1</span><span class="p">,</span> <span class="n">inputs</span><span class="o">.</span><span class="n">shape</span><span class="p">[</span><span class="mi">0</span><span class="p">],</span> <span class="n">inputs</span><span class="o">.</span><span class="n">shape</span><span class="p">[</span><span class="mi">1</span><span class="p">])</span>

        <span class="n">amb_T</span> <span class="o">=</span> <span class="n">inputs</span><span class="p">[:,</span> <span class="mi">0</span><span class="p">,</span> <span class="o">-</span><span class="mi">1</span><span class="p">]</span>  <span class="c1"># It doesn&#39;t change throughout the cycle</span>
        <span class="n">tech</span> <span class="o">=</span> <span class="n">inputs</span><span class="p">[:,</span> <span class="mi">0</span><span class="p">,</span> <span class="o">-</span><span class="mi">2</span><span class="p">]</span>  <span class="c1"># It doesn&#39;t change throughout the cycle</span>
        <span class="n">lstm_inputs</span> <span class="o">=</span> <span class="n">inputs</span><span class="p">[:,</span> <span class="p">:,</span> <span class="p">:</span><span class="o">-</span><span class="mi">2</span><span class="p">]</span>

        <span class="n">lstm_out</span><span class="p">,</span> <span class="n">_</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">lstm</span><span class="p">(</span><span class="n">lstm_inputs</span><span class="p">)</span>  <span class="c1"># LSTM output</span>
        <span class="n">shp_out</span> <span class="o">=</span> <span class="n">lstm_out</span><span class="o">.</span><span class="n">shape</span>              <span class="c1"># Its shape</span>
        <span class="n">lstm_out</span> <span class="o">=</span> <span class="n">F</span><span class="o">.</span><span class="n">dropout</span><span class="p">(</span><span class="n">lstm_out</span><span class="p">,</span> <span class="bp">self</span><span class="o">.</span><span class="n">dropout_value</span><span class="p">)</span>  <span class="c1"># dropout layer</span>

        <span class="c1"># Pooling layer, according to the type chosen:</span>
        <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">pooling_layer</span> <span class="o">==</span> <span class="s1">&#39;last&#39;</span><span class="p">:</span>
            <span class="n">pool_out</span> <span class="o">=</span> <span class="n">lstm_out</span><span class="p">[:,</span> <span class="o">-</span><span class="mi">1</span><span class="p">,</span> <span class="p">:]</span><span class="o">.</span><span class="n">view</span><span class="p">(</span><span class="n">shp_out</span><span class="p">[</span><span class="mi">0</span><span class="p">],</span> <span class="bp">self</span><span class="o">.</span><span class="n">hidden_dim</span><span class="p">)</span>
        <span class="k">elif</span> <span class="bp">self</span><span class="o">.</span><span class="n">pooling_layer</span> <span class="o">==</span> <span class="s1">&#39;mean&#39;</span><span class="p">:</span>
            <span class="n">pool_out</span> <span class="o">=</span> <span class="n">th</span><span class="o">.</span><span class="n">mean</span><span class="p">(</span><span class="n">lstm_out</span><span class="p">,</span> <span class="n">dim</span><span class="o">=</span><span class="mi">1</span><span class="p">)</span><span class="o">.</span><span class="n">view</span><span class="p">(</span><span class="n">shp_out</span><span class="p">[</span><span class="mi">0</span><span class="p">],</span>
                                                     <span class="bp">self</span><span class="o">.</span><span class="n">hidden_dim</span><span class="p">)</span>
        <span class="k">elif</span> <span class="bp">self</span><span class="o">.</span><span class="n">pooling_layer</span> <span class="o">==</span> <span class="s1">&#39;bi_mean&#39;</span><span class="p">:</span>
            <span class="n">pool_out</span> <span class="o">=</span> <span class="n">th</span><span class="o">.</span><span class="n">mean</span><span class="p">(</span><span class="n">lstm_out</span><span class="p">[:,</span> <span class="p">:,</span> <span class="p">:</span><span class="bp">self</span><span class="o">.</span><span class="n">hidden_dim</span><span class="p">]</span><span class="o">*</span>
                               <span class="n">lstm_out</span><span class="p">[:,</span> <span class="p">:,</span> <span class="bp">self</span><span class="o">.</span><span class="n">hidden_dim</span><span class="p">:],</span>
                               <span class="n">dim</span><span class="o">=</span><span class="mi">1</span><span class="p">)</span><span class="o">.</span><span class="n">view</span><span class="p">(</span><span class="n">shp_out</span><span class="p">[</span><span class="mi">0</span><span class="p">],</span> <span class="bp">self</span><span class="o">.</span><span class="n">hidden_dim</span><span class="p">)</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="k">raise</span> <span class="ne">NameError</span><span class="p">(</span><span class="s2">&quot;Unknown pooling layer type: &quot;</span><span class="o">+</span><span class="bp">self</span><span class="o">.</span><span class="n">pooling_layer</span><span class="p">)</span>

        <span class="c1"># Linear layer</span>
        <span class="n">output</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">lin1</span><span class="p">(</span><span class="n">th</span><span class="o">.</span><span class="n">cat</span><span class="p">([</span><span class="n">pool_out</span><span class="p">,</span>
                                   <span class="n">amb_T</span><span class="o">.</span><span class="n">view</span><span class="p">(</span><span class="n">shp_out</span><span class="p">[</span><span class="mi">0</span><span class="p">],</span> <span class="mi">1</span><span class="p">),</span>
                                   <span class="n">tech</span><span class="o">.</span><span class="n">view</span><span class="p">(</span><span class="n">shp_out</span><span class="p">[</span><span class="mi">0</span><span class="p">],</span> <span class="mi">1</span><span class="p">)],</span> <span class="n">dim</span><span class="o">=</span><span class="mi">1</span><span class="p">))</span>

        <span class="k">return</span> <span class="n">output</span></div></div>

<div class="viewcode-block" id="Torch_Dataset_LSTM"><a class="viewcode-back" href="../sphinx/LSTMchem.html#LSTM_chemistry.Torch_Dataset_LSTM">[docs]</a><span class="k">class</span> <span class="nc">Torch_Dataset_LSTM</span><span class="p">(</span><span class="n">Dataset_Base</span><span class="p">):</span>
    <span class="sd">&quot;&quot;&quot;Creates a pytorch Dataset class that can readily be loaded with torch&#39;s</span>
<span class="sd">    Loader class for training and validation.</span>

<span class="sd">    This class is just like :class:`Torch_Dataset_LSTM` except that it adds the</span>
<span class="sd">    battery&#39;s chemistry to the inputs - a value indicating if the battery is</span>
<span class="sd">    either of type Li-ion (0) or Na-ion (1). Check the other module&#39;s</span>
<span class="sd">    documentation for more information.</span>

<span class="sd">    .. warning::</span>
<span class="sd">        This class by itself is not capable of treating two dataset types in one</span>
<span class="sd">        go. Rather, it should be used for each dataset separately, and the</span>
<span class="sd">        datasets should then be mixed using :class:`Torch_Dataset_Mixer`</span>

<span class="sd">    Parameters</span>
<span class="sd">    ----------</span>
<span class="sd">    Battery_list : list[Clean_Battery]</span>
<span class="sd">        List with the Batteries that we want to use for creating the dataset.</span>
<span class="sd">    delta : int</span>
<span class="sd">        The size of the sliding window used to generate the x_i&#39;s.</span>
<span class="sd">    model_version : {1, 2, 3, 4, 5}</span>
<span class="sd">        An integer indicating which LSTM version to use.</span>
<span class="sd">        if ``version`` == 1: then only I and V data will be used.</span>
<span class="sd">        elif ``version`` == 2: then I, V and T will be taken into account.</span>
<span class="sd">        elif ``version`` == 3: then I, V and amb_T will be taken into account.</span>
<span class="sd">        elif ``version`` == 4: then I, V and amb_T will be taken into account,</span>
<span class="sd">        but amb_T will enter directly in the last step, the NN.</span>
<span class="sd">        elif ``version`` == 5: then I, V, T and amb_T will be taken into account,</span>
<span class="sd">        mixing models 2 and 4. Redundant.</span>
<span class="sd">    print_bool : bool, default = False</span>
<span class="sd">        Whether or not to print some information while the code runs.</span>
<span class="sd">        Namely, if we want to print the battery&#39;s name and the number of points.</span>
<span class="sd">    time_step : int, optional</span>
<span class="sd">        The desired time step for the resampling procedure.</span>
<span class="sd">        If ``None`` is given, than a time step will be automatically generated</span>
<span class="sd">        by the method ``time_step_function``.</span>
<span class="sd">    threshold : float, default = 0.1</span>
<span class="sd">        The minimum capacity value to be considered as relevant [A.h].</span>
<span class="sd">    min_len : int, default = 10</span>
<span class="sd">        The minimum amount of points a charge cycle must have to be considered</span>
<span class="sd">        as relevant.</span>
<span class="sd">    fixed_len : int, optional</span>
<span class="sd">        if different than ``None`` (default value), then the charge and discharge</span>
<span class="sd">        curves will be limited to ``fixed_len`` points. This will override</span>
<span class="sd">        ``min_len``.</span>
<span class="sd">    norm_type : {&#39;zscore&#39;, &#39;minmax&#39;}</span>
<span class="sd">        A string indicating which kind of normalization to do.</span>
<span class="sd">    norm : tuple(Tensor, Tensor, Tensor, Tensor, string), optional</span>
<span class="sd">        A tuple containing all of the information necessary for normalization.</span>
<span class="sd">        In entered as input, ``norm_type`` will be overridden by norm[4] and the</span>
<span class="sd">        given information will be used for the normalization</span>

<span class="sd">    adimensionalize : bool, default = True</span>
<span class="sd">        Whether or not to make variables dimensionless before adding them to the</span>
<span class="sd">        inputs and output lists.</span>

<span class="sd">        * The Capacity (output) is normalized by the nominal capacity</span>
<span class="sd">          (``Q_nominal``);</span>

<span class="sd">        * The Current is normalized by the C rate (``C_rate``) -</span>
<span class="sd">          which is the current necessary for charging the battery in one hour</span>
<span class="sd">          (theoretically);</span>

<span class="sd">        * The Voltage is normalized by the nominal voltage (``V_nominal``),</span>
<span class="sd">          the voltage at the plateau in the CV part of the charge curve.</span>

<span class="sd">        The values of these parameters are defined inside of each battery class.</span>

<span class="sd">    cycle_lim : int, optional</span>
<span class="sd">        The greatest cycle number to take into account for the dataset creation.</span>
<span class="sd">        Default equals ``1e6`` meaning that no cycles will be ignored.</span>

<span class="sd">    Attributes</span>
<span class="sd">    ----------</span>
<span class="sd">    dataset_name : str</span>
<span class="sd">        The name of the dataset (&#39;Dataset_Nasa&#39;, for instance).</span>
<span class="sd">    batteries : list[str]</span>
<span class="sd">        A list with the file name of each battery used.</span>
<span class="sd">    dataset_format : str</span>
<span class="sd">        A string indicating the type of data format used: &#39;You et al. [56]&#39;.</span>
<span class="sd">    inputs : list[Tensors]</span>
<span class="sd">        A list with the input tensors for each cycle.</span>
<span class="sd">    output : Tensor</span>
<span class="sd">        A tensor with the output capacity tensors for each cycle.</span>

<span class="sd">    Raises</span>
<span class="sd">    ------</span>
<span class="sd">    AssertionError</span>
<span class="sd">        If the specified value of ``delta`` is &lt; 1.</span>
<span class="sd">        If no batteries are given.</span>
<span class="sd">        If the specified version is invalid.</span>
<span class="sd">        If ``model_version`` is 2 or 5 and ``self.dataset_name`` is</span>
<span class="sd">        ``Clean_Coin_Battery``.</span>
<span class="sd">    ValueError</span>
<span class="sd">        If the model_version is unknown.</span>

<span class="sd">    Examples</span>
<span class="sd">    --------</span>
<span class="sd">    &gt;&gt;&gt; from torch.utils.data import Dataset</span>
<span class="sd">    &gt;&gt;&gt; from LSTM import Torch_Dataset_LSTM</span>
<span class="sd">    &gt;&gt;&gt; delta = 10</span>
<span class="sd">    &gt;&gt;&gt; version = 2</span>
<span class="sd">    &gt;&gt;&gt; with open(&#39;B0005.txt&#39;, &#39;rb&#39;) as f:</span>
<span class="sd">    ...     Battery = pickle.load(f)</span>
<span class="sd">    ...</span>
<span class="sd">    &gt;&gt;&gt; train_dataset = Torch_Dataset_LSTM([Battery], delta, version,</span>
<span class="sd">    ...                                    fixed_len=150, print_bool=True)</span>
<span class="sd">    B0005</span>
<span class="sd">    165</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="k">def</span> <span class="fm">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">Battery_list</span><span class="p">,</span> <span class="n">delta</span><span class="p">,</span> <span class="n">model_version</span><span class="p">,</span> <span class="n">print_bool</span><span class="o">=</span><span class="kc">False</span><span class="p">,</span>
                 <span class="n">time_step</span><span class="o">=</span><span class="kc">None</span><span class="p">,</span> <span class="n">threshold</span><span class="o">=</span><span class="mf">0.1</span><span class="p">,</span> <span class="n">min_len</span><span class="o">=</span><span class="mi">10</span><span class="p">,</span> <span class="n">fixed_len</span><span class="o">=</span><span class="mi">150</span><span class="p">,</span>
                 <span class="n">norm_type</span><span class="o">=</span><span class="s1">&#39;zscore&#39;</span><span class="p">,</span> <span class="n">norm</span><span class="o">=</span><span class="kc">None</span><span class="p">,</span> <span class="n">adimensionalize</span><span class="o">=</span><span class="kc">True</span><span class="p">,</span>
                 <span class="n">cycle_lim</span><span class="o">=</span><span class="mf">1e6</span>
                 <span class="p">):</span>

        <span class="nb">super</span><span class="p">()</span><span class="o">.</span><span class="fm">__init__</span><span class="p">()</span>

        <span class="k">assert</span> <span class="n">delta</span> <span class="o">&gt;=</span> <span class="mi">1</span><span class="p">,</span> <span class="s1">&#39;delta must be greater or equal to one&#39;</span>
        <span class="k">assert</span> <span class="nb">len</span><span class="p">(</span><span class="n">Battery_list</span><span class="p">)</span> <span class="o">&gt;</span> <span class="mi">0</span><span class="p">,</span> <span class="s1">&#39;No Batteries informed&#39;</span>
        <span class="k">assert</span> <span class="n">model_version</span> <span class="ow">in</span> <span class="p">[</span><span class="mi">1</span><span class="p">,</span> <span class="mi">2</span><span class="p">,</span> <span class="mi">3</span><span class="p">,</span> <span class="mi">4</span><span class="p">,</span> <span class="mi">5</span><span class="p">],</span> <span class="s1">&#39;Invalid version&#39;</span>

        <span class="k">if</span> <span class="n">fixed_len</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
            <span class="k">if</span> <span class="n">delta</span> <span class="o">!=</span> <span class="mi">1</span><span class="p">:</span>
                <span class="n">min_len</span> <span class="o">=</span> <span class="nb">max</span><span class="p">(</span><span class="n">delta</span> <span class="o">-</span> <span class="mi">1</span><span class="p">,</span> <span class="n">min_len</span><span class="p">)</span>
                <span class="c1"># min_len is the minimum sequence length (number of points) that</span>
                <span class="c1"># the charge cycle must have to be taken into account.</span>
            <span class="k">else</span><span class="p">:</span>
                <span class="n">min_len</span> <span class="o">=</span> <span class="mi">1</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="n">min_len</span> <span class="o">=</span> <span class="n">fixed_len</span> <span class="o">+</span> <span class="n">delta</span>

        <span class="c1"># Dataset related</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">dataset_name</span> <span class="o">=</span> <span class="nb">type</span><span class="p">(</span><span class="n">Battery_list</span><span class="p">[</span><span class="mi">0</span><span class="p">])</span><span class="o">.</span><span class="vm">__name__</span>  <span class="c1"># The dataset used</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">batteries</span> <span class="o">=</span> <span class="p">[]</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">adimensionalize</span> <span class="o">=</span> <span class="n">adimensionalize</span>

        <span class="k">for</span> <span class="n">Battery</span> <span class="ow">in</span> <span class="n">Battery_list</span><span class="p">:</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">batteries</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">Battery</span><span class="o">.</span><span class="n">Name</span><span class="o">+</span><span class="s1">&#39;.txt&#39;</span><span class="p">)</span>

        <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">dataset_name</span> <span class="o">==</span> <span class="s1">&#39;Clean_Coin_Battery&#39;</span><span class="p">:</span>
            <span class="k">assert</span> <span class="n">model_version</span> <span class="ow">in</span> <span class="p">[</span><span class="mi">1</span><span class="p">,</span> <span class="mi">3</span><span class="p">,</span> <span class="mi">4</span><span class="p">],</span> <span class="s2">&quot;Can&#39;t use models 2 or 5 with&quot;</span> \
                <span class="s2">&quot;Clean_Coin_Battery. No data on temperature during cycling.&quot;</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">tech</span> <span class="o">=</span> <span class="mf">1.</span>
            <span class="n">new_battery_list</span> <span class="o">=</span> <span class="p">[]</span>
            <span class="k">for</span> <span class="n">Battery</span> <span class="ow">in</span> <span class="n">Battery_list</span><span class="p">:</span>
                <span class="k">for</span> <span class="n">cell</span> <span class="ow">in</span> <span class="n">Battery</span><span class="o">.</span><span class="n">cell</span><span class="p">:</span>
                    <span class="n">new_battery_list</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">cell</span><span class="p">)</span>
            <span class="n">Battery_list</span> <span class="o">=</span> <span class="n">new_battery_list</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">tech</span> <span class="o">=</span> <span class="mi">0</span>

        <span class="bp">self</span><span class="o">.</span><span class="n">min_len</span> <span class="o">=</span> <span class="n">min_len</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">fixed_len</span> <span class="o">=</span> <span class="n">fixed_len</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">Battery_list</span> <span class="o">=</span> <span class="n">Battery_list</span>

        <span class="k">if</span> <span class="n">time_step</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
            <span class="n">time_step</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">time_step_function</span><span class="p">()</span>

        <span class="bp">self</span><span class="o">.</span><span class="n">dataset_format</span> <span class="o">=</span> <span class="s1">&#39;You et al. [56]&#39;</span>   <span class="c1"># The data format used</span>
        <span class="c1"># LSTM related</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">delta</span> <span class="o">=</span> <span class="n">delta</span>                        <span class="c1"># The amount of points per xi</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">model_version</span> <span class="o">=</span> <span class="n">model_version</span>        <span class="c1"># The model version</span>
        <span class="c1"># Cleaning related:</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">time_step</span> <span class="o">=</span> <span class="n">time_step</span>                <span class="c1"># The time step for resampling</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">threshold</span> <span class="o">=</span> <span class="n">threshold</span>                <span class="c1"># The threshold for cleaning</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">cycle_lim</span> <span class="o">=</span> <span class="n">cycle_lim</span>

        <span class="n">ent</span> <span class="o">=</span> <span class="p">[]</span>        <span class="c1"># Inputs list</span>
        <span class="n">sai</span> <span class="o">=</span> <span class="p">[]</span>        <span class="c1"># Output list</span>

        <span class="k">for</span> <span class="n">Battery</span> <span class="ow">in</span> <span class="n">Battery_list</span><span class="p">:</span>
            <span class="k">try</span><span class="p">:</span>
                <span class="n">threshold</span> <span class="o">=</span> <span class="n">threshold</span> <span class="o">/</span> <span class="p">(</span><span class="n">Battery</span><span class="o">.</span><span class="n">mass</span><span class="p">)</span>
            <span class="k">except</span> <span class="ne">AttributeError</span><span class="p">:</span>
                <span class="k">pass</span>
            <span class="n">C_rate</span> <span class="o">=</span> <span class="n">Battery</span><span class="o">.</span><span class="n">C_rate</span>
            <span class="n">Q_nominal</span> <span class="o">=</span> <span class="n">Battery</span><span class="o">.</span><span class="n">Q_nominal</span>
            <span class="n">V_nominal</span> <span class="o">=</span> <span class="n">Battery</span><span class="o">.</span><span class="n">V_nominal</span>

            <span class="k">if</span> <span class="n">print_bool</span><span class="p">:</span>
                <span class="nb">print</span><span class="p">(</span><span class="n">Battery</span><span class="o">.</span><span class="n">Name</span><span class="p">)</span>
            <span class="k">for</span> <span class="n">index</span><span class="p">,</span> <span class="n">cycle_couple</span> <span class="ow">in</span> <span class="nb">enumerate</span><span class="p">(</span><span class="n">Battery</span><span class="o">.</span><span class="n">cycle_couple</span><span class="p">):</span>
                <span class="k">if</span> <span class="n">index</span> <span class="o">&gt;</span> <span class="n">cycle_lim</span><span class="p">:</span>
                    <span class="c1"># If we&#39;ve gone over the limit number of cycles to test.</span>
                    <span class="k">break</span>
                <span class="n">chr_cycle</span> <span class="o">=</span> <span class="n">cycle_couple</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span>
                <span class="n">dis_cycle</span> <span class="o">=</span> <span class="n">cycle_couple</span><span class="p">[</span><span class="mi">1</span><span class="p">]</span>

                <span class="c1"># print(time_step)</span>
                <span class="n">Data</span> <span class="o">=</span> <span class="n">Resampling_flexible</span><span class="p">(</span><span class="n">chr_cycle</span><span class="p">,</span> <span class="n">variable</span><span class="o">=</span><span class="s1">&#39;Time&#39;</span><span class="p">,</span>
                                           <span class="n">time_step</span><span class="o">=</span><span class="n">time_step</span><span class="p">,</span> <span class="n">min_len</span><span class="o">=</span><span class="n">min_len</span><span class="p">)</span>

                <span class="k">if</span> <span class="n">Data</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
                    <span class="c1"># When there aren&#39;t enough points in the cycle, Cycle_t is</span>
                    <span class="c1"># returned as None</span>
                    <span class="k">continue</span>
                <span class="c1"># Cycle_t = Data[:, 0]</span>

                <span class="n">Cycle_i</span> <span class="o">=</span> <span class="n">Data</span><span class="p">[:,</span> <span class="mi">1</span><span class="p">]</span>
                <span class="n">Cycle_v</span> <span class="o">=</span> <span class="n">Data</span><span class="p">[:,</span> <span class="mi">2</span><span class="p">]</span>
                <span class="n">Cycle_T</span> <span class="o">=</span> <span class="n">Data</span><span class="p">[:,</span> <span class="mi">3</span><span class="p">]</span> <span class="c1"># NOT THE TEMPERATURE IF DATASET_TYPE =</span>
                                     <span class="c1"># COIN</span>

                <span class="k">if</span> <span class="n">adimensionalize</span><span class="p">:</span>
                    <span class="n">Cycle_i</span> <span class="o">=</span> <span class="n">Cycle_i</span><span class="o">/</span><span class="n">C_rate</span>
                    <span class="n">Cycle_v</span> <span class="o">=</span> <span class="n">Cycle_v</span><span class="o">/</span><span class="n">V_nominal</span>

                <span class="c1"># Cleaning will take away NaN&#39;s, the beginning and the end of</span>
                <span class="c1"># the discharge curves (that is, the part before the current</span>
                <span class="c1"># reaches the CC value and the part after when the current</span>
                <span class="c1"># reaches its cut-off value ``i_cutoff``) and resample the time</span>
                <span class="c1"># according to the given time step ``time_step``.</span>

                <span class="c1"># Calculating the real number of xis we&#39;ve got</span>
                <span class="k">if</span> <span class="n">fixed_len</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
                    <span class="n">Nb</span> <span class="o">=</span> <span class="nb">len</span><span class="p">(</span><span class="n">Cycle_i</span><span class="p">)</span> <span class="o">-</span> <span class="n">delta</span> <span class="o">+</span> <span class="mi">1</span>  <span class="c1"># Number of xis in this cycle</span>
                <span class="k">else</span><span class="p">:</span>
                    <span class="n">Nb</span> <span class="o">=</span> <span class="n">fixed_len</span>
                <span class="c1"># min_len already take care of the cases where Nb &lt;= 0.</span>

                <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">model_version</span> <span class="o">==</span> <span class="mi">1</span><span class="p">:</span>
                    <span class="n">XT</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">zeros</span><span class="p">((</span><span class="n">Nb</span><span class="p">,</span> <span class="mi">2</span> <span class="o">*</span> <span class="n">delta</span><span class="o">+</span><span class="mi">1</span><span class="p">))</span>
                    <span class="c1"># Regrouped xi info for one whole cycle</span>

                    <span class="k">for</span> <span class="n">t</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="n">Nb</span><span class="p">):</span>  <span class="c1"># We&#39;re going to make one xi for each t</span>
                        <span class="n">xi</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">concatenate</span><span class="p">([</span><span class="n">Cycle_i</span><span class="p">[</span><span class="n">t</span><span class="p">:</span><span class="n">t</span> <span class="o">+</span> <span class="n">delta</span><span class="p">],</span>  <span class="c1"># Current</span>
                                             <span class="n">Cycle_v</span><span class="p">[</span><span class="n">t</span><span class="p">:</span><span class="n">t</span> <span class="o">+</span> <span class="n">delta</span><span class="p">],</span>
                                             <span class="bp">self</span><span class="o">.</span><span class="n">tech</span><span class="o">*</span><span class="n">np</span><span class="o">.</span><span class="n">ones</span><span class="p">([</span><span class="mi">1</span><span class="p">])])</span>  <span class="c1"># Voltage</span>
                        <span class="c1"># &quot;Add&quot; it to the XT tensor that regroups them.</span>
                        <span class="n">XT</span><span class="p">[</span><span class="n">t</span><span class="p">,</span> <span class="p">:]</span> <span class="o">=</span> <span class="n">xi</span>

                <span class="k">elif</span> <span class="bp">self</span><span class="o">.</span><span class="n">model_version</span> <span class="o">==</span> <span class="mi">2</span><span class="p">:</span>
                    <span class="n">XT</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">zeros</span><span class="p">((</span><span class="n">Nb</span><span class="p">,</span> <span class="mi">3</span> <span class="o">*</span> <span class="n">delta</span><span class="o">+</span><span class="mi">1</span><span class="p">))</span>
                    <span class="k">for</span> <span class="n">t</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="n">Nb</span><span class="p">):</span>
                        <span class="n">xi</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">concatenate</span><span class="p">([</span><span class="n">Cycle_i</span><span class="p">[</span><span class="n">t</span><span class="p">:</span><span class="n">t</span> <span class="o">+</span> <span class="n">delta</span><span class="p">],</span>
                                             <span class="n">Cycle_v</span><span class="p">[</span><span class="n">t</span><span class="p">:</span><span class="n">t</span> <span class="o">+</span> <span class="n">delta</span><span class="p">],</span>
                                             <span class="n">Cycle_T</span><span class="p">[</span><span class="n">t</span><span class="p">:</span><span class="n">t</span> <span class="o">+</span> <span class="n">delta</span><span class="p">],</span>
                                             <span class="bp">self</span><span class="o">.</span><span class="n">tech</span><span class="o">*</span><span class="n">np</span><span class="o">.</span><span class="n">ones</span><span class="p">([</span><span class="mi">1</span><span class="p">])])</span><span class="c1"># Temperature</span>

                        <span class="n">XT</span><span class="p">[</span><span class="n">t</span><span class="p">,</span> <span class="p">:]</span> <span class="o">=</span> <span class="n">xi</span>

                <span class="k">elif</span> <span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">model_version</span> <span class="o">==</span> <span class="mi">3</span><span class="p">)</span> <span class="ow">or</span> <span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">model_version</span> <span class="o">==</span> <span class="mi">4</span><span class="p">):</span>
                    <span class="n">XT</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">zeros</span><span class="p">((</span><span class="n">Nb</span><span class="p">,</span> <span class="mi">2</span> <span class="o">*</span> <span class="n">delta</span> <span class="o">+</span> <span class="mi">2</span><span class="p">))</span>

                    <span class="k">for</span> <span class="n">t</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="n">Nb</span><span class="p">):</span>
                        <span class="n">xi</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">concatenate</span><span class="p">([</span><span class="n">Cycle_i</span><span class="p">[</span><span class="n">t</span><span class="p">:</span><span class="n">t</span> <span class="o">+</span> <span class="n">delta</span><span class="p">],</span>
                                             <span class="n">Cycle_v</span><span class="p">[</span><span class="n">t</span><span class="p">:</span><span class="n">t</span> <span class="o">+</span> <span class="n">delta</span><span class="p">],</span>
                                             <span class="n">chr_cycle</span><span class="o">.</span><span class="n">amb_T</span><span class="o">*</span><span class="n">np</span><span class="o">.</span><span class="n">ones</span><span class="p">([</span><span class="mi">1</span><span class="p">]),</span>
                                             <span class="bp">self</span><span class="o">.</span><span class="n">tech</span><span class="o">*</span><span class="n">np</span><span class="o">.</span><span class="n">ones</span><span class="p">([</span><span class="mi">1</span><span class="p">])])</span>
                                             <span class="c1"># Ambient temperature</span>

                        <span class="n">XT</span><span class="p">[</span><span class="n">t</span><span class="p">,</span> <span class="p">:]</span> <span class="o">=</span> <span class="n">xi</span>

                <span class="k">elif</span> <span class="bp">self</span><span class="o">.</span><span class="n">model_version</span> <span class="o">==</span> <span class="mi">5</span><span class="p">:</span>
                    <span class="n">XT</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">zeros</span><span class="p">((</span><span class="n">Nb</span><span class="p">,</span> <span class="mi">3</span> <span class="o">*</span> <span class="n">delta</span> <span class="o">+</span> <span class="mi">2</span><span class="p">))</span>

                    <span class="k">for</span> <span class="n">t</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="n">Nb</span><span class="p">):</span>
                        <span class="n">xi</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">concatenate</span><span class="p">([</span><span class="n">Cycle_i</span><span class="p">[</span><span class="n">t</span><span class="p">:</span><span class="n">t</span> <span class="o">+</span> <span class="n">delta</span><span class="p">],</span>
                                             <span class="n">Cycle_v</span><span class="p">[</span><span class="n">t</span><span class="p">:</span><span class="n">t</span> <span class="o">+</span> <span class="n">delta</span><span class="p">],</span>
                                             <span class="n">Cycle_T</span><span class="p">[</span><span class="n">t</span><span class="p">:</span><span class="n">t</span> <span class="o">+</span> <span class="n">delta</span><span class="p">],</span>
                                             <span class="n">chr_cycle</span><span class="o">.</span><span class="n">amb_T</span><span class="o">*</span><span class="n">np</span><span class="o">.</span><span class="n">ones</span><span class="p">([</span><span class="mi">1</span><span class="p">]),</span>
                                             <span class="bp">self</span><span class="o">.</span><span class="n">tech</span><span class="o">*</span><span class="n">np</span><span class="o">.</span><span class="n">ones</span><span class="p">([</span><span class="mi">1</span><span class="p">])])</span>

                        <span class="n">XT</span><span class="p">[</span><span class="n">t</span><span class="p">,</span> <span class="p">:]</span> <span class="o">=</span> <span class="n">xi</span>
                <span class="k">else</span><span class="p">:</span>
                    <span class="k">raise</span> <span class="ne">ValueError</span><span class="p">(</span><span class="s2">&quot;Unknown version: &quot;</span><span class="o">+</span><span class="nb">str</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">model_version</span><span class="p">))</span>

                <span class="n">Capacity</span> <span class="o">=</span> <span class="n">dis_cycle</span><span class="o">.</span><span class="n">data</span><span class="o">.</span><span class="n">capacity</span><span class="o">*</span><span class="n">np</span><span class="o">.</span><span class="n">ones</span><span class="p">(</span><span class="mi">1</span><span class="p">)</span>

                <span class="k">if</span> <span class="n">Capacity</span><span class="o">.</span><span class="n">item</span><span class="p">()</span> <span class="o">&lt;</span> <span class="n">threshold</span><span class="p">:</span>
                    <span class="c1"># If it&#39;s considered to be too close to zero</span>
                    <span class="k">continue</span>

                <span class="k">if</span> <span class="n">adimensionalize</span><span class="p">:</span>
                    <span class="n">Capacity</span><span class="o">=</span><span class="n">Capacity</span><span class="o">/</span><span class="n">Q_nominal</span>

                <span class="c1"># The XT tensor represents one cycle and is thus one input</span>
                <span class="n">ent</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">th</span><span class="o">.</span><span class="n">from_numpy</span><span class="p">(</span><span class="n">XT</span><span class="p">)</span><span class="o">.</span><span class="n">float</span><span class="p">())</span>
                <span class="c1"># The capacity is one output.</span>
                <span class="n">sai</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">Capacity</span><span class="p">)</span>

            <span class="c1"># The number of inputs and outputs must be the same</span>
            <span class="k">assert</span> <span class="nb">len</span><span class="p">(</span><span class="n">ent</span><span class="p">)</span> <span class="o">==</span> <span class="nb">len</span><span class="p">(</span><span class="n">sai</span><span class="p">),</span> <span class="s1">&#39;Unequal input and output lengths&#39;</span>

        <span class="n">inputs</span><span class="p">,</span> <span class="n">output</span><span class="p">,</span> <span class="n">norm</span> <span class="o">=</span> <span class="n">Normalize</span><span class="p">(</span><span class="n">ent</span><span class="p">,</span> <span class="n">sai</span><span class="p">,</span> <span class="n">norm_type</span><span class="o">=</span><span class="n">norm_type</span><span class="p">,</span>
                                         <span class="n">norm</span><span class="o">=</span><span class="n">norm</span><span class="p">)</span>

        <span class="k">if</span> <span class="n">print_bool</span><span class="p">:</span>
            <span class="nb">print</span><span class="p">(</span><span class="nb">len</span><span class="p">(</span><span class="n">inputs</span><span class="p">))</span>

        <span class="bp">self</span><span class="o">.</span><span class="n">inputs</span> <span class="o">=</span> <span class="n">inputs</span>  <span class="c1"># saving the inputs</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">output</span> <span class="o">=</span> <span class="n">output</span>  <span class="c1"># saving the outputs</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">norm</span> <span class="o">=</span> <span class="n">norm</span>  <span class="c1"># saving the norm</span>

        <span class="bp">self</span><span class="o">.</span><span class="n">path</span> <span class="o">=</span> <span class="kc">None</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">transform</span> <span class="o">=</span> <span class="kc">None</span>

    <span class="k">def</span> <span class="fm">__len__</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="k">return</span> <span class="nb">len</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">inputs</span><span class="p">)</span>

    <span class="k">def</span> <span class="fm">__getitem__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">item</span><span class="p">):</span>

        <span class="n">ent</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">inputs</span><span class="p">[</span><span class="n">item</span><span class="p">]</span>
        <span class="n">sai</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">output</span><span class="p">[</span><span class="n">item</span><span class="p">]</span>

        <span class="k">return</span> <span class="n">ent</span><span class="p">,</span> <span class="n">sai</span></div>

<div class="viewcode-block" id="Torch_Dataset_Mixer"><a class="viewcode-back" href="../sphinx/LSTMchem.html#LSTM_chemistry.Torch_Dataset_Mixer">[docs]</a><span class="k">class</span> <span class="nc">Torch_Dataset_Mixer</span><span class="p">(</span><span class="n">Dataset</span><span class="p">):</span>
    <span class="sd">&quot;&quot;&quot;Class for mixing different dataset types.</span>

<span class="sd">    .. note::</span>
<span class="sd">        Notice that the inputs and outputs are normalised prior to this class&#39;s</span>
<span class="sd">        initialization, and that each dataset that is being mixed will have</span>
<span class="sd">        different normalisation parameters. In this sense, this class cannot</span>
<span class="sd">        have a ``norm`` attribute and thus attempts to denormalize outputs</span>
<span class="sd">        directly from this class will fail. Because of this, when simulating</span>
<span class="sd">        results with :obj:`Training.simulate`, make sure you call it with</span>
<span class="sd">        ``denormalize=False`` so that no ``AttributeError`` is raised.</span>

<span class="sd">    .. warning::</span>
<span class="sd">        Tests weren&#39;t very successful so development has been halted. Missing</span>
<span class="sd">        functionalities and attributes may cause ``AttributeError``s in other</span>
<span class="sd">        functions.</span>

<span class="sd">    Parameters</span>
<span class="sd">    ----------</span>
<span class="sd">    dataset_list : list[Torch_Dataset_LSTM]</span>
<span class="sd">        A list of the different datasets to be used.</span>
<span class="sd">    renorm : bool, optional</span>
<span class="sd">        Whether or not to renormalize all the data with respect to the whole</span>
<span class="sd">        set. Experimental, didn&#39;t yield good results.</span>

<span class="sd">    &quot;&quot;&quot;</span>

    <span class="k">def</span> <span class="fm">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">dataset_list</span><span class="p">,</span> <span class="n">renorm</span><span class="o">=</span><span class="kc">False</span><span class="p">):</span>

        <span class="nb">super</span><span class="p">()</span><span class="o">.</span><span class="fm">__init__</span><span class="p">()</span>
        <span class="kn">from</span> <span class="nn">Cleaning</span> <span class="kn">import</span> <span class="n">Denormalize</span><span class="p">,</span> <span class="n">Normalize</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">dataset_list</span> <span class="o">=</span> <span class="n">dataset_list</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">inputs</span> <span class="o">=</span> <span class="p">[]</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">output</span> <span class="o">=</span> <span class="n">th</span><span class="o">.</span><span class="n">Tensor</span><span class="p">([])</span>
        <span class="n">inputs_list</span> <span class="o">=</span> <span class="p">[]</span>
        <span class="n">output_list</span> <span class="o">=</span> <span class="p">[]</span>
        <span class="k">for</span> <span class="n">dataset</span> <span class="ow">in</span> <span class="n">dataset_list</span><span class="p">:</span>
            <span class="k">if</span> <span class="n">renorm</span><span class="p">:</span>
                <span class="k">for</span> <span class="n">tensor</span> <span class="ow">in</span> <span class="n">dataset</span><span class="o">.</span><span class="n">inputs</span><span class="p">:</span>
                    <span class="n">inputs_list</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">Denormalize</span><span class="p">(</span><span class="n">tensor</span><span class="p">,</span> <span class="n">dataset</span><span class="o">.</span><span class="n">norm</span><span class="p">,</span> <span class="n">inputs</span><span class="o">=</span><span class="kc">True</span><span class="p">))</span>
                <span class="n">output_list</span> <span class="o">=</span> <span class="n">output_list</span> <span class="o">+</span> <span class="n">Denormalize</span><span class="p">(</span><span class="n">dataset</span><span class="o">.</span><span class="n">output</span><span class="p">,</span> <span class="n">dataset</span><span class="o">.</span><span class="n">norm</span><span class="p">,</span> <span class="n">inputs</span><span class="o">=</span><span class="kc">False</span><span class="p">)</span><span class="o">.</span><span class="n">tolist</span><span class="p">()</span>
            <span class="k">else</span><span class="p">:</span>
                <span class="bp">self</span><span class="o">.</span><span class="n">inputs</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">inputs</span> <span class="o">+</span> <span class="n">dataset</span><span class="o">.</span><span class="n">inputs</span>
                <span class="bp">self</span><span class="o">.</span><span class="n">output</span> <span class="o">=</span> <span class="n">th</span><span class="o">.</span><span class="n">cat</span><span class="p">([</span><span class="bp">self</span><span class="o">.</span><span class="n">output</span><span class="p">,</span> <span class="n">dataset</span><span class="o">.</span><span class="n">output</span><span class="p">],</span> <span class="n">dim</span><span class="o">=</span><span class="mi">0</span><span class="p">)</span>

        <span class="k">if</span> <span class="n">renorm</span><span class="p">:</span>
            <span class="n">inputs</span><span class="p">,</span> <span class="n">outputs</span><span class="p">,</span> <span class="n">norm</span> <span class="o">=</span> <span class="n">Normalize</span><span class="p">(</span><span class="n">inputs_list</span><span class="p">,</span> <span class="n">output_list</span><span class="p">)</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">inputs</span> <span class="o">=</span> <span class="n">inputs</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">output</span> <span class="o">=</span> <span class="n">outputs</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">norm</span> <span class="o">=</span> <span class="n">norm</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">norm</span> <span class="o">=</span> <span class="kc">None</span>

    <span class="k">def</span> <span class="fm">__len__</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="k">return</span> <span class="nb">len</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">inputs</span><span class="p">)</span>

    <span class="k">def</span> <span class="fm">__getitem__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">item</span><span class="p">):</span>
        <span class="n">ent</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">inputs</span><span class="p">[</span><span class="n">item</span><span class="p">]</span>
        <span class="n">sai</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">output</span><span class="p">[</span><span class="n">item</span><span class="p">]</span>
        <span class="k">return</span> <span class="n">ent</span><span class="p">,</span> <span class="n">sai</span>

    <span class="k">def</span> <span class="nf">report</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="n">string</span> <span class="o">=</span> <span class="s1">&#39;&#39;</span>
        <span class="k">for</span> <span class="n">dataset</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">dataset_list</span><span class="p">:</span>
            <span class="n">string</span> <span class="o">+=</span> <span class="s1">&#39;</span><span class="se">\n\n</span><span class="s1">&#39;</span><span class="o">+</span><span class="nb">str</span><span class="p">(</span><span class="n">dataset</span><span class="p">)</span><span class="o">+</span><span class="s1">&#39;</span><span class="se">\n</span><span class="s1">&#39;</span>
            <span class="n">string</span> <span class="o">+=</span> <span class="n">dataset</span><span class="o">.</span><span class="n">report</span><span class="p">()</span>
        <span class="k">return</span> <span class="n">string</span>

    <span class="k">def</span> <span class="nf">dataset_info</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">name</span><span class="p">):</span>
        <span class="c1">#TODO</span>
        <span class="k">pass</span></div>

<div class="viewcode-block" id="norm_adapt"><a class="viewcode-back" href="../sphinx/LSTMchem.html#LSTM_chemistry.norm_adapt">[docs]</a><span class="k">def</span> <span class="nf">norm_adapt</span><span class="p">(</span><span class="n">norm</span><span class="p">,</span> <span class="n">tech</span><span class="o">=</span><span class="mi">0</span><span class="p">):</span>
    <span class="sd">&quot;&quot;&quot;Function for adapting a given ``norm`` tuple for LSTM_chemistry dataset.</span>

<span class="sd">    This function basically adds an entry to the normalisation parameters</span>
<span class="sd">    corresponding to the battery&#39;s chemistry. It&#39;s useful for when user wants to</span>
<span class="sd">    use a ``norm`` calculated for other variants for this one.</span>

<span class="sd">    Parameters</span>
<span class="sd">    ----------</span>
<span class="sd">    norm : tuple</span>
<span class="sd">        A norm tuple.</span>
<span class="sd">    tech : {0, 1}, default = 0</span>
<span class="sd">        An ``int`` indicating which battery chemistry is used (0 is Li-ion and</span>
<span class="sd">        1 is Na-ion).</span>

<span class="sd">    Returns</span>
<span class="sd">    -------</span>
<span class="sd">    tuple</span>
<span class="sd">        A norm tuple as normal.</span>

<span class="sd">    Raises</span>
<span class="sd">    ------</span>
<span class="sd">    AssertionError</span>
<span class="sd">        If the ``tech`` is different than 0 or 1.</span>
<span class="sd">    &quot;&quot;&quot;</span>

    <span class="k">assert</span> <span class="n">tech</span> <span class="ow">in</span> <span class="p">[</span><span class="mi">0</span><span class="p">,</span><span class="mi">1</span><span class="p">],</span> <span class="s2">&quot;Invalid chemistry type: &quot;</span><span class="o">+</span><span class="nb">str</span><span class="p">(</span><span class="n">tech</span><span class="p">)</span>

    <span class="n">inputs_mean</span> <span class="o">=</span> <span class="n">th</span><span class="o">.</span><span class="n">cat</span><span class="p">([</span><span class="n">norm</span><span class="p">[</span><span class="mi">0</span><span class="p">],</span> <span class="n">th</span><span class="o">.</span><span class="n">Tensor</span><span class="p">([</span><span class="n">tech</span><span class="p">])])</span>
    <span class="n">inputs_stdv</span> <span class="o">=</span> <span class="n">th</span><span class="o">.</span><span class="n">cat</span><span class="p">([</span><span class="n">norm</span><span class="p">[</span><span class="mi">1</span><span class="p">],</span> <span class="n">th</span><span class="o">.</span><span class="n">Tensor</span><span class="p">([</span><span class="mi">1</span><span class="p">])])</span>

    <span class="k">return</span> <span class="p">(</span><span class="n">inputs_mean</span><span class="p">,</span> <span class="n">inputs_stdv</span><span class="p">,</span> <span class="n">norm</span><span class="p">[</span><span class="mi">2</span><span class="p">],</span> <span class="n">norm</span><span class="p">[</span><span class="mi">3</span><span class="p">],</span> <span class="n">norm</span><span class="p">[</span><span class="mi">4</span><span class="p">])</span></div>
</pre></div>

              </div>
              
              
              <div class='prev-next-bottom'>
                

              </div>
              
          </main>
          

      </div>
    </div>
  
  <script src="../_static/js/index.1c5a1a01449ed65a7b51.js"></script>

  <footer class="footer mt-5 mt-md-0">
  <div class="container">
    
    <div class="footer-item">
      <p class="copyright">
    &copy; Copyright 2022, Antonio ROCHA AZEVEDO.<br/>
</p>
    </div>
    
    <div class="footer-item">
      <p class="sphinx-version">
Created using <a href="http://sphinx-doc.org/">Sphinx</a> 4.0.2.<br/>
</p>
    </div>
    
  </div>
</footer>
  </body>
</html>